package org.fouram.service;

import java.util.List;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.plugin.weixin.cp.util.WXCpMessageUtil;
import org.fouram.entity.SapUser;
import org.fouram.enums.DelFlagEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class SyncSapUserToWxService extends BaseService {

	@Autowired
	private WxUserService wxUserService;
	@Autowired
	private SapUserService sapUserService;
	@Autowired
	private WxDepartService wxDepartService;
	
	@Transactional
	public void taskBiz() throws Exception {
		// 更新微信部门
		wxDepartService.saveWxDeparts();
		// 更新微信用户
		wxUserService.saveWxUsers();
		// 更新所有数据无效
		sapUserService.updateAllDelFlag(DelFlagEnum.UNABLE.getCode());
		// 保存SAP用户数据-数据没变化的result状态保持不变
		sapUserService.saveOrUpdateSapUsers();
		// 更新异常情况，敏感数据、入职
		sapUserService.updateAbnormalResult();
		// 更新用户头像
		sapUserService.updateAvatars();
		// NORMAL数据更新同步企业微信
		sapUserService.updateAllNormalSyncWxResult();
		// 发送禁用企业微信账号信息
		this.sendQuitUserMsg();
	}

	// 发送禁用企业微信账号信息
	private void sendQuitUserMsg() throws Exception {
		List<SapUser> unableSapUsers = sapUserService.selectPrimaryListByDelFlag(DelFlagEnum.UNABLE.getCode());
		if (unableSapUsers.size() > 0) {
			WXCpMessageUtil.sendQuitUserMsg("离职用户" + unableSapUsers.size() + "个，请确认");
		}
	}
}
